#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    //ofBackground(255);// change by vol ?
    ofSetRectMode(OF_RECTMODE_CENTER);
    microphoneStream.setup(this, 0, 2, 44100, 256, 4);
    left=new float[256];
    right=new float[256];
    
    
    bufferCounter	= 0;
    drawCounter		= 0;
    smoothedVol     = 0.0;
    scaledVol		= 0.0;
    
    
    
    background.load("abcd.jpg");
    
}




//--------------------------------------------------------------
void ofApp::update(){
    //lets scale the vol up to a 0-1 range
    scaledVol = ofMap(smoothedVol, 0.0, 0.17, 0.0, 1.0, true);
    
    
}

//--------------------------------------------------------------
void ofApp::draw(){
    
    background.draw(0, 0);
    
    //ofDrawCircle(ofRandom(ofGetWidth()), ofRandom(ofGetHeight()), ofRandom(10));
    ofDrawBitmapString("Scaled volume "+ofToString(scaledVol), 10, 10);
    
    //for (int k=0; k<ofGetWidth(); k++) {
      //  ofDrawLine(0, 0, k, ofGetWidth());
    
    
    for(int i=0;i<microphoneStream.getBufferSize();i++){
        //LEFT
        float leftX=ofMap(i,0,255,0,ofGetWidth()/2);
        
        if(scaledVol<0.0001)
        ofSetColor(left[i],i,scaledVol*100000);
        ofDrawCircle(leftX,ofRandom(ofGetHeight()), right[i]*1000);
        
        if(scaledVol>0.0001 || scaledVol<0.0003)
            ofSetColor(left[i],i,scaledVol*300000);
        ofDrawCircle(leftX+300,ofRandom(ofGetHeight()), right[i]*1000);
        
        if(scaledVol>0.0003 || scaledVol<0.0005)
            ofSetColor(left[i],i,scaledVol*500000);
        ofDrawCircle(leftX+600,ofRandom(ofGetHeight()), right[i]*1000);

        
        //RIGHT
        float rightX=ofMap(i,0,255,ofGetWidth()/2,ofGetWidth());
        if(scaledVol>0.0005 || scaledVol>0.001)
        ofSetColor(scaledVol*700000,scaledVol*50000,right[i]);
        ofDrawCircle(rightX/2,ofRandom(ofGetHeight()), right[i]*1000);
        
        
        
    }
    
}

//--------------------------------------------------------------
void ofApp::audioIn(float *input, int buffersize, int nChannels){
    for(int k=0; k<buffersize; k++){
        //left[k]=input[k*2];
        //right[k]=input[k*2+1];
        
    }
    
    float curVol = 0.0;
    
    // samples are "interleaved"
    int numCounted = 0;
    
    //lets go through each sample and calculate the root mean square which is a rough way to calculate volume
    for (int i = 0; i < buffersize; i++){
        left[i]		= input[i*2]*0.5;
        right[i]	= input[i*2+1]*0.5;
        
        curVol += left[i] * left[i];
        curVol += right[i] * right[i];
        numCounted+=2;
    }
    
    //this is how we get the mean of rms :)
    curVol /= (float)numCounted;
    
    // this is how we get the root of rms :)
    curVol = sqrt( curVol );
    
    smoothedVol *= 0.93;
    smoothedVol += 0.07 * curVol;
    
    bufferCounter++;
    
    
}



//--------------------------------------------------------------
void ofApp::keyPressed(int key){
    
}

//--------------------------------------------------------------
void ofApp::keyReleased(int key){
    
}

//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y ){
    
}

//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){
    
}

//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){
    
}

//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){
    
}

//--------------------------------------------------------------
void ofApp::mouseEntered(int x, int y){
    
}

//--------------------------------------------------------------
void ofApp::mouseExited(int x, int y){
    
}

//--------------------------------------------------------------
void ofApp::windowResized(int w, int h){
    
}

//--------------------------------------------------------------
void ofApp::gotMessage(ofMessage msg){
    
}

//--------------------------------------------------------------
void ofApp::dragEvent(ofDragInfo dragInfo){ 
    
}
